###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2006 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
Source10: kmodtool2
%define kmodtool bash %{SOURCE10}
%{!?kversion: %define kversion 2.6.18-128.el5}
# hint: this can he overridden with "--define kversion foo" on the rpmbuild command line, e.g.
# --define "kversion 2.6.16-1.2096_FC5"

%define kmod_name gfs
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""
%ifarch ppc
%define smpvar smp
%endif
%ifarch i686 x86_64 ia64
%define xenvar xen
#define kdumpvar kdump
%endif
%ifarch i686
%define PAEvar PAE
%endif
%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?xenvar} %{?kdumpvar} %{?PAEvar}}
# hint: this can he overridden with "--define kvariant foo bar" on the rpmbuild command line, e.g.
# --define 'kvariant "" smp' 

Name:           %{kmod_name}-kmod
Version:        0.1.31
Release:        3%{?dist}
Summary:        %{kmod_name} kernel modules

Group:          System Environment/Kernel
License:        GPL
URL:            http://sources.redhat.com/cluster
Source0:        gfs-kernel-%{version}.tar.gz
Patch1:		gfs-kernel-extras.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:  i686 x86_64 ia64 ppc64 ppc64iseries s390x

%description
gfs - The Global File System is a symmetric, shared-disk, cluster file
system.

# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate_kmp %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}


%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -T -a 0
pushd %{kmod_name}-kernel-%{version}*
%patch1 -p1 -b .extras
sed -i '/RELEASE_NAME/s/"<CVS>"/"%{version}-%{release}"/' src/gfs/gfs.h
popd
for kvariant in %{kvariants} ; do
    cp -a %{kmod_name}-kernel-%{version} _kmod_build_${kvariant}
done


%build
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    pushd _kmod_build_$kvariant
    ./configure --kernel_src=${ksrc} --libdir=%{_libdir} --incdir=%{_includedir}
    make -C "${ksrc}" SUBDIRS=${PWD} modules %{?_smp_mflags}
    popd
done


%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants}
do
    pushd _kmod_build_$kvariant
    make install \
         DESTDIR=$RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}
         DESTDIR=$RPM_BUILD_ROOT
         INST_DIR=$RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}
    popd
done
# Temporarily executable for stripping, fixed later in %%files.
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Tue Nov 11 2008 Chris Feist <cfeist@redhat.com> - 0.1.31-1
- Fixed a hang in GFS due to wasteful prefetching of locks.

* Mon Nov 10 2008 Chris Feist <cfeist@redhat.com> - 0.1.30-1
- gfs_lock() now handles F_CANCELLK correctly.
- Resolves: rhbz#466677

* Thu Nov 06 2008 Chris Feist <cfeist@redhat.com> - 0.1.29-1
- Provide backwards compatability with older gfs-kmod packages.
- Resolves: rhbz#462892

* Tue Oct 14 2008 Chris Feist <cfeist@redhat.com> - 0.1.28-1
- More fixes for the noatime/nodiratime mount options.
- Resolves: rhbz#457473

* Mon Oct 06 2008 Chris Feist <cfeist@redhat.com> - 0.1.26-1
- noatime and nodiratime mount options have been fixed.
- Resolves: rhbz#457473

* Mon Sep 15 2008 Chris Feist <cfeist@redhat.com> - 0.1.25-1
- Fixed GFS unlinked inode metadata leak
- Resolves: rhbz#298931

* Thu Jul 31 2008 Chris Feist <cfeist@redhat.com> - 0.1.24-1
- Created gfs1 specific lock modules
- Fixed a bug causing an "unable to handle kernel paging request" message.
- Faster bitfit algorithm has been added.
- Don't cancel glocks when writing to a hidden file.
- gfs_mount no longer hangs when run if no more journals are available.
- gfs-kernel now uses device major:minor
- Fixed the gfs_glock_is_locked_by_me assertion.
- Resolves: rhbz#450209 rhbz#446085 rhbz#446085 rhbz#425421 rhbz#431952 rhbz#429343

* Thu Jan 24 2008 Chris Feist <cfeist@redhat.com> - 0.1.22-1
- gfs_tool now recognizes GFS files sytems on ppc
- Fixed a NULL pointer dereference.
- gfs_quota is now able to perform efficient list operations
- Resolves: rhbz#429633 rhbz#426291 rhbz#430134

* Mon Jan 14 2008 Chris Feist <cfeist@redhat.com> - 0.1.21-1
- Lock methods are now removed when using the lock_nolock protocol
- Permission checks have been removed from xattr operations
- Locking order in gfs_get_parent() has been fixed
- Resolves: rhbz#244343 rhbz#323111 rhbz#400651

* Tue Oct 02 2007 Chris Feist <cfeist@redhat.com> - 0.1.19-7
- Build for new kernel (2.6.18-53.el5)
- Related: rhbz#267001

* Wed Sep 12 2007 Chris Feist <cfeist@redhat.com> - 0.1.19-5
- Build for new kernel (2.6.18-47.el5)
- Resolves: rhbz#267001

* Mon Jul 23 2007 Chris Feist <cfeist@redhat.com> - 0.1.19-4
- Build for new kernel (2.6.18-36.el5)
- Resolves: rhbz#249333

* Fri Jul 13 2007 Jon Masters <jcm@redhat.com> - 0.1.19-3
- Fix problem calling RPM from within Anaconda.

* Mon Jan 15 2007 Chris Feist <cfeist@redhat.com> - 0.1.16-3
- Build based in kABI deps using code from jcm@redhat.com

* Thu Dec 21 2006 Chris Feist <cfeist@redhat.com> - 0.1.16-1
- New sources
- Resolves: rhbz#219876

* Mon Dec 19 2006 Chris Feist <cfeist@redhat.com> - 0.1.15-1
- Building for PAE kernel
- Resolves: rhbz#218551

* Fri Dec 08 2006 Chris Feist <cfeist@redhat.com> - 0.1.14-3
- Building for PAE kernel
- Resolves: rhbz#218986

* Mon Dec 04 2006 Chris Feist <cfeist@redhat.com> - 0.1.14-1
- Built for new kernel
- Resolves: rhbz#217893 rhbz#215962

* Thu Nov 28 2006 Chris Feist <cfeist@redhat.com> - 0.1.13-2
- Built for new kernel
- Resolves: rhbz#217893

* Mon Nov 20 2006 Chris Feist <cfeist@redhat.com> - 0.1.13-1
- New upstream sources.

* Fri Oct 27 2006 Chris Feist <cfeist@redhat.com> - 0.1.11-1
- New upstream sources.

* Mon Oct 16 2006 Chris Feist <cfeist@redhat.com> - 0.1.7-1
- New upstream sources to fix AIO issues.

* Mon Oct 16 2006 Chris Feist <cfeist@redhat.com> - 0.1.6-1
- New upstream sources.

* Fri Oct 13 2006 Chris Feist <cfeist@redhat.com> - 0.1.5-1
- New upstream sources.

* Mon Oct 9 2006 Chris Feist <cfeist@redhat.com> - 0.1.4-1
- New upstream sources (fixes selinux issue).

* Fri Oct 6 2006 Chris Feist <cfeist@redhat.com> - 0.1.3-8
- Temporarily disable ppc builds.

* Wed Sep 27 2006 Chris Feist <cfeist@redhat.com> - 0.1.3-7
- Use version-release instead of <CVS> for release name.

* Mon Sep 25 2006 Chris Feist <cfeist@redhat.com> - 0.1.3-1
- Add support for ia64 xen.
- New upstream sources.

* Thu Sep 21 2006 Tim Powers <timp@redhat.com> - 0.1.2-5
- rebuild for kernel-2.6.18-1.2685.el5

* Wed Sep 20 2006 Tim Powers <timp@redhat.com> - 0.1.2-4
- bump and rebuild

* Mon Sep 18 2006 Chris Feist <cfeist@redhat.com> - 0.1.2-3
- Enable xen builds.

* Wed Sep 13 2006 Chris Feist <cfeist@redhat.com> - 0.1.2-1
- New upstream sources.

* Wed Aug 30 2006 Chris Feist <cfeist@redhat.com> - 0.1.1-9
- bump and rebuild against kernel-2.6.17-1.2519.4.21.el5

* Tue Aug 29 2006 Dennis Gregorovic <dgregor@redhat.com> - 0.1.1-9
- bump and rebuild against kernel-2.6.17-1.2519.4.18.el5

* Fri Aug 25 2006 Chris Feist <cfeist@redaht.com> - 0.1.1-8
- Don't build for kdump kernel

* Fri Aug 18 2006 Tim Powers <timp@redhat.com> - 0.1.1-7
- bump and rebuild against kernel-2.6.17-1.2519.4.5.el5

* Thu Aug 17 2006 Chris Feist <cfeist@redhat.com> - 0.1.1-6
- Built for new kernel.

* Tue Aug 15 2006 Chris Feist <cfeist@redhat.com> - 0.1.1-5
- Don't require kmod-gfs-common for now.

* Tue Aug 15 2006 Chris Feist <cfeist@redhat.com> - 0.1.1-4
- Added a provides for gfs-kmod-common

* Fri Aug 11 2006 Chris Feist <cfeist@redhat.com> - 0.1.1-0
- New upstream sources.

* Fri Aug 4 2006 Chris Feist <cfeist@redhat.com> - 0.1.0-3
- Re-enable other kernel types & disabled broken xen build

* Thu Aug 3 2006 Chris Feist <cfeist@redhat.com> - 0.1.0-2
- Initial Build
